function [G, der, eta, sig2_med, dereta]=cal_der(s_a, s_b, s_c, deltas, alphas, betas, Sf1, sig2_M, sig2_G, Xcov)
q=length(Xcov);
nn=length(Sf1);
Lambda_t_all=cumsum(Sf1);
eta=betas(1:q)'*Xcov'+betas(4+q-1)*alphas(1:q)'*Xcov'+(betas(3+q-1)+betas(4+q-1)*alphas(q+2))*deltas(1:q)'*Xcov'+betas(2+q-1)*s_a+betas(4+q-1)*alphas(q+1)*s_b+(betas(3+q-1)+betas(4+q-1)*alphas(q+2))*deltas(q+1)*s_c;

sig2_med=sig2_M*(betas(end-1)+betas(end)*alphas(end))^2+sig2_G*betas(end)^2+7;
[G, dG, ddG, d3G]=Gtransform_norm(Lambda_t_all*exp(eta), 0, sig2_med);
betemp=betas(3+q-1)+betas(4+q-1)*alphas(q+2);
detemp=Xcov*deltas(1:q)+deltas(q+1)*s_c;
altemp=Xcov*alphas(1:q)+alphas(q+1)*s_b;
dereta=[Xcov*betemp, betemp*s_c, Xcov*betas(4+q-1), betas(4+q-1)*s_b, betas(4+q-1)*detemp, Xcov, s_a, detemp, altemp+alphas(q+2)*detemp];
dertemp2=[(Lambda_t_all*dereta)'; (triu(ones(nn, nn), 0))];
dertemp3=dertemp2.*exp(eta);
der=repmat((exp(-G).*(-dG))', size(dertemp3, 1), 1).*dertemp3;
